import java.util.Random;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * Kan gebruikt worden om de andere klassen te testen.
 */
public class Tester {

    private static final Random RG = new Random ();

    /**
     * Geef een bord terug van willekeurig gewicht (tussen 100 en 300.0, ), 
     * afmeting (tussen 1 en 3 cm) en breekbaarheid (33% kans op een breekbaar bord)
     */
    public Bord willekeurigBord () {
        return new Bord (
            100.0 + 200.0*RG.nextDouble(),
            1.0 + 2.0* RG.nextDouble (),
            RG.nextInt (3) < 1
        );
    }
    
    /**
     * Creëer een lijst met willekeurige borden. Het aantal
     * borden varieert tussen 5 en 15.
     */
    public List<Bord> willekeurigeBorden () {
        List<Bord> lijst = new ArrayList<> ();
        int aantal = 5 + RG.nextInt (6);
        for (int i=0; i < aantal; i++) {
            lijst.add (willekeurigBord());
        }
        return lijst;
    }

    /**
     * Creëer een lijst van borden om te testen
     */
    public List<Bord> maakTestlijst () {
        
        return Arrays.asList (
            new Bord(150.0, 1.5, true),
            new Bord(100.0, 2.5, false),
            new Bord(100.0, 2.5, true),
            new Bord(250.0, 2, false),
            new Bord(150.0, 2, true),
            new Bord(150.0, 2.5, false),
            new Bord(100.0, 1, true),
            new Bord(150.0, 1, false),
            new Bord(150.0, 1.5, false),
            new Bord(100.0, 2.5, false)
        ); // hulpmethode uit de Java-bibliotheek
    }
    
    /**
     * Doe de test
     */
    public void doeTest() {
        Kistenvuller dv = new Kistenvuller ();
        //dv.nieuweKist (new ZwakkeKist (4.8));
        dv.nieuweKist (new SterkeKist (480));
        //dv.nieuweKist (new Stapelkist ());
        dv.vulKisten (maakTestlijst());
    }

}
